#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <winsock2.h>
#include "resource.h"

#define APPNAME		"WhatTunes"
#define APPVERSION	"0.1"
#define	WC_MAIN		"WHATTUNES"

#define WM_SELECT	WM_USER + 0x622

static LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);

SOCKET sock;
char   current[1024];

int WINAPI
WinMain(
HINSTANCE hInstance,
HINSTANCE hinstPrev,
LPSTR     lpszCmdLine,
int       nCmdShow
)
{
  WNDCLASS wc;
  HWND     hWnd;
  MSG      msg;
  WSADATA  wsaData;

  WSAStartup(MAKEWORD(2,0), &wsaData);

  ZeroMemory(&wc, sizeof(wc));
  wc.lpfnWndProc   = MainWndProc;
  wc.hInstance     = hInstance;
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  wc.lpszClassName = WC_MAIN;
  if (!RegisterClass(&wc)) return -1;

  hWnd = CreateWindowEx(WS_EX_TOOLWINDOW,
			WC_MAIN, APPNAME,
			WS_POPUP | WS_THICKFRAME,
			200, 200,
			200, 200,
			NULL, NULL, hInstance, NULL);
  if (!hWnd) return -1;
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);

  while (GetMessage(&msg, NULL, 0, 0)) {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }

  WSACleanup();

  return (int)msg.wParam;
}

static LRESULT CALLBACK
MainWndProc(
HWND hWnd,
UINT uMsg,
WPARAM wParam,
LPARAM lParam
)
{
  struct sockaddr_in addr;
  int                ret;
  PAINTSTRUCT        ps;
  HDC                hDC;
  RECT               rc;
  HMENU              hMenu;
  POINT              pt;

  switch (uMsg) {
  case WM_CREATE:
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if (!sock) {
      MessageBox(hWnd, "socketG[", APPNAME, MB_OK | MB_ICONSTOP);
      return -1;
    }
    addr.sin_family = AF_INET;
    addr.sin_port = htons(12345);
    addr.sin_addr.S_un.S_addr = INADDR_ANY;
    ret = bind(sock, (struct sockaddr *)&addr, sizeof(addr));
    if (ret == -1) {
      MessageBox(hWnd, "bindG[FłɋNĂۂł", APPNAME, MB_OK | MB_ICONSTOP);
      return -1;
    }
    ret = WSAAsyncSelect(sock, hWnd, WM_SELECT, FD_READ);
    if (ret == -1) {
      MessageBox(hWnd, "WSAAsyncSelectG[", APPNAME, MB_OK | MB_ICONSTOP);
      return -1;
    }
    return 0;
  case WM_DESTROY:
    WSAAsyncSelect(sock, hWnd, 0, 0);
    closesocket(sock);
    PostQuitMessage(0);
    return 0;
  case WM_SELECT:
    ret = recv((int)wParam, current, sizeof(current), 0);
    if (ret >= 0)current[ret] = '\0';
    GetClientRect(hWnd, &rc);
    InvalidateRect(hWnd, &rc, TRUE);
    break;
  case WM_LBUTTONDOWN:
    SendMessage(hWnd, WM_SYSCOMMAND, HTCAPTION | SC_MOVE, 0);
    return 0;
  case WM_RBUTTONUP:
    hMenu = LoadMenu((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
		     MAKEINTRESOURCE(IDR_MAINMENU));
    hMenu = GetSubMenu(hMenu, 0);
    pt.x = LOWORD(lParam);
    pt.y = HIWORD(lParam);
    ClientToScreen(hWnd, &pt);
    TrackPopupMenu(hMenu, 0, pt.x, pt.y, 0, hWnd, NULL);
    return 0L;
  case WM_SIZE:
    GetClientRect(hWnd, &rc);
    InvalidateRect(hWnd, &rc, TRUE);
    return 0;
  case WM_PAINT:
    hDC = BeginPaint(hWnd, &ps);
    GetClientRect(hWnd, &rc);
    DrawText(hDC, current, -1, &rc, DT_NOPREFIX | DT_WORDBREAK);
    EndPaint(hWnd, &ps);
    return 0;
  case WM_COMMAND:
    switch (LOWORD(wParam)) {
    case IDM_ABOUT:
      MessageBox(hWnd, APPNAME " Version " APPVERSION "\n"
		 "Copyright (C) YAMADA Satoshi",
		 APPNAME "ɂ", MB_OK | MB_ICONINFORMATION);
      return 0;
    case IDM_EXIT:
      DestroyWindow(hWnd);
      return 0;
    }
  }

  return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

// vi:ts=8 sw=2
